#!/bin/bash
# Usage: 
# Read gcerbuffer.var to get the list of Cmd
# Launch the NextCmd
# Write gcerbuffer.var with the list of Cmd 
#                without the Cmd previously Launch 
###############################################
# Exemple : nextcmd1=led8_0;nextcmd2=led4_1;nextcmd3=0;nextcmd5=0;nextcmd6=0;nextcmd7=0;nextcmd8=0
# type relayurl http://192.168.1.202:40405/command/relayboard/rb1-led0/high
###############################################
# Config Var
debugmode=0
rbswitchtime="60s" # 60s between 2 relay changes
gcerbbufferfile="<PATH TO>/gcerbuffer/gcerbuffer.var"
relayurlbase="http://<DMG IP>:40405/command/relayboard/<RELAY BOARD NAME>-"
scriptpathnname="<PATH TO>/gcerbuffer/MCEsetrelay.sh"
logfile="<PATH TO>/gcerbuffer/gcerbdaemon.log"

trap "interuptGB" EXIT

interuptGB() {
    echo "GceRBDaemon Exiting..."
}


function returnrelaycommand(){
        cmdline=$1
	case "$cmdline" in
	"led1_0") #Relay1 OFF
		endurl="led1/low"
		;;
	"led1_1") #Relay1 ON
		endurl="led1/high"
        	;;
	"led2_0") #Relay2 OFF
                endurl="led2/low"
                ;;
        "led2_1") #Relay2 ON
                endurl="led2/high"
                ;;
	"led3_0") #Relay3 OFF
                endurl="led3/low"
                ;;
        "led3_1") #Relay3 ON
                endurl="led3/high"
                ;;
	"led4_0") #Relay4 OFF
                endurl="led4/low"
                ;;
        "led4_1") #Relay4 ON
                endurl="led4/high"
                ;;
	"led5_0") #Relay5 OFF
                endurl="led5/low"
                ;;
        "led5_1") #Relay5 ON
                endurl="led5/high"
                ;;
	"led6_0") #Relay6 OFF
                endurl="led6/low"
                ;;
        "led6_1") #Relay6 ON
                endurl="led6/high"
                ;;
        "led7_0") #Relay7 OFF
                endurl="led7/low"
                ;;
        "led7_1") #Relay7 ON
                endurl="led7/high"
                ;;
        "led8_0") #Relay8 OFF
                endurl="led8/low"
                ;;
        "led8_1") #Relay8 ON
                endurl="led8/high"
                ;;
	*) # ERROR
		endurl="E"
		;;
	esac
	if  [ "$endurl" = "E" ]; then
		echo ""
	else
		echo "$relayurlbase$endurl"
	fi
}

while true; do
	eval $(cat $gcerbbufferfile)
	if [ "$debugmode" = "1" ]; then
		echo $(cat $gcerbbufferfile) >> $logfile
	fi
	if [ "$nextcmd1" == "0" ]; then
		if [ "$debugmode" = "1" ]; then
	                echo "No NextRelayCmd" >> $logfile
	        fi
	else
		relayurl=$(returnrelaycommand $nextcmd1)
		if [ "$debugmode" = "1" ]; then
		        echo "NextRelayCmd=$nextcmd1" >> $logfile
			echo "FullRelayCmd=$relayurl" >> $logfile
		fi
		if [ $($scriptpathnname $relayurl) = "OK" ];then
	                if [ "$debugmode" = "1" ]; then
	                        echo "Relay Cmd OK" >> $logfile
	                fi
	        else
	                if [ "$debugmode" = "1" ]; then
                        echo "Relay Cmd NOK" >> $logfile
	                fi
		fi

		# Move Stack
		echo "nextcmd1=$nextcmd2;nextcmd2=$nextcmd3;nextcmd3=$nextcmd4;nextcmd4=$nextcmd5;nextcmd5=$nextcmd6;nextcmd6=$nextcmd7;nextcmd7=$nextcmd8;nextcmd8=0" > $gcerbbufferfile
	fi
	#Wait "rbswitchtime" secondes
	sleep $rbswitchtime
done
