#!/bin/bash
# Usage: gcerbset.sh ledX_Y
# Get parameter ledX_Y
# Read gcerbbuffer.var to get the list of Cmd
# Place the cmd in the last position in the list
# Write gcerbbuffer.var with the list of Cmd
# Return OK or NOK if buffer is full or cmd is nok 
###############################################
# Exemple : nextcmd1=led8_0;nextcmd2=led4_1;nextcmd3=0;nextcmd5=0;nextcmd6=0;nextcmd7=0;nextcmd8=0
###############################################
# Config Var
debugmode=0
gcerbbufferfile="<PATH TO>/gcerbuffer/gcerbuffer.var"
setresult=0

if [ "$1" = "0" ]; then
	if [ "$debugmode" = "1" ]; then
		echo "No Args"
        fi
else
	nemcmdline=$1
fi
posix=0
eval $(cat $gcerbbufferfile)
if [ "$debugmode" = "1" ]; then
	echo $(cat $gcerbbufferfile)
fi


if [ "$nextcmd8" = "0" ]; then
	posix=8
fi
if [ "$nextcmd7" = "0" ]; then
	posix=7
fi
if [ "$nextcmd6" = "0" ]; then
	posix=6
fi
if [ "$nextcmd5" = "0" ]; then
	posix=5
fi
if [ "$nextcmd4" = "0" ]; then
	posix=4
fi
if [ "$nextcmd3" = "0" ]; then
        posix=3
fi
if [ "$nextcmd2" = "0" ]; then
        posix=2
fi
if [ "$nextcmd1" = "0" ]; then
	if [ "$debugmode" = "1" ]; then
                echo "No NextRelayCmd"
        fi
	posix=1	
fi

if [ "$posix" = "0" ]; then
	if [ "$debugmode" = "1" ]; then
                echo "The Buffer is Full"
        fi
	# NOK
	setresult=0
else
	if [ "$debugmode" = "1" ]; then
		echo "Posix=$posix newcmdline=$nemcmdline"
	fi
	# check if the relay cmd already exist
	if [ "$nextcmd1" = "$nemcmdline" ] || [ "$nextcmd2" = "$nemcmdline" ] || [ "$nextcmd3" = "$nemcmdline" ] || [ "$nextcmd4" = "$nemcmdline" ] || [ "$nextcmd5" = "$nemcmdline" ] || [ "$nextcmd6" = "$nemcmdline" ] || [ "$nextcmd7" = "$nemcmdline" ]; then
		if [ "$debugmode" = "1" ]; then
			echo "cmdline already in the list !"
		fi
		# NOK
		setresult=0
	else
		varnametomod=$(echo -ne "nextcmd$posix")
		eval ${varnametomod}=$nemcmdline

		# write Stack
		echo "nextcmd1=$nextcmd1;nextcmd2=$nextcmd2;nextcmd3=$nextcmd3;nextcmd4=$nextcmd4;nextcmd5=$nextcmd5;nextcmd6=$nextcmd6;nextcmd7=$nextcmd7;nextcmd8=$nextcmd8" > $gcerbbufferfile
        	setresult=1
	fi
fi

if [ "$setresult" = "1" ]; then
	printf "OK"
else
	printf "NOK"
fi
